function [new_alphas, Ga]=svmsmo_update(Y,C,train,old_alphas,index1,index2,old_Ga);
%[new_alphas,etas,Ga]  = linesearch_dual_reg_SKM_brent(Y,train,as,ds,old_alphas,index1,index2,e_constr,f_constr,tol,itmax,epsilon,old_Ga)
global K_stack DKDa aDKDa

if Y(index1)~=Y(index2),
    L=max(old_alphas(index2)-old_alphas(index1),0);
    H=min(C(index2),C(index1)+old_alphas(index2)-old_alphas(index1));
else
    L=max(old_alphas(index2)+old_alphas(index1)-C(index1),0);
    H=min(C(index2),old_alphas(index2)+old_alphas(index1));
end

E1=Y(index1)*(DKDa(index1)-1);
E2=Y(index2)*(DKDa(index2)-1);
zeta=K_stack(train(index1),train(index1))+K_stack(train(index2),train(index2))-2*K_stack(train(index1),train(index2));
new_alpha2=old_alphas(index2)+(Y(index2)*(E1-E2))/zeta;
new_alpha2=min(max(L,new_alpha2),H);
new_alpha1=old_alphas(index1)+Y(index1)*Y(index2)*(old_alphas(index2)-new_alpha2);
dalpha2=new_alpha2-old_alphas(index2);
dalpha1=Y(index1)*Y(index2)*(old_alphas(index2)-new_alpha2);
new_alphas=old_alphas;
new_alphas(index1)=new_alpha1;
new_alphas(index2)=new_alpha2;
aDKDa=aDKDa+2*dalpha1*DKDa(index1)+2*dalpha2*DKDa(index2)+dalpha1^2*K_stack(train(index1),train(index1))+...
    dalpha2^2*K_stack(train(index2),train(index2))+...
    +2*dalpha1*dalpha2*Y(index1)*Y(index2)*K_stack(train(index1),train(index2));
DKDa=DKDa+Y.*(K_stack(train,[train(index1) train(index2)])*[Y(index1)*dalpha1;Y(index2)*dalpha2]);
Ga=0.5*aDKDa-sum(new_alphas);

if Ga>old_Ga+0.00000001;
    error('SVMsmo increase');
end
